﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using System.Threading;
using Infragistics.UltraChart.Core.Primitives;
using System.Diagnostics;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Resources;

namespace WinChartTreemapRing
{
    public partial class Form1 : Form
    {
        List<DataWedgeLabel> datawagelabel = new List<DataWedgeLabel>();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraChart1.DataSource = GetLineData();
            
            DataTable dt = (DataTable)ultraChart1.DataSource;


        }
        private DataTable GetLineData()
        {
            DataTable mydata = new DataTable();
            //Define the columns and their names
            mydata.Columns.Add("Series Label", typeof(string));
            mydata.Columns.Add("Point A", typeof(int));
            mydata.Columns.Add("Series Label1", typeof(string));
            //Add the rows of data
            mydata.Rows.Add(new Object[] { "Line A", 1,"Line a"});
            mydata.Rows.Add(new Object[] { "Line A", 3,"Line b"});
            mydata.Rows.Add(new Object[] { "Line C", 4, "Line c" });
            mydata.Rows.Add(new Object[] { "Line D", 5, "Line d" });
            return mydata;
        }

        private Override GenerateOverride(int col, int row)
        {
            Random rnd = new Random();
            byte R = (byte)rnd.Next(0, 255);
            byte G = (byte)rnd.Next(0, 255);
            byte B = (byte)rnd.Next(0, 255);

            Color c = Color.FromArgb(R, G, B);

            Override override1 = new Override();
            override1.Column = col; // match all data columns
            override1.Row = row; // row #0 only;
            override1.PE =
              new PaintElement(c);

            Thread.Sleep(rnd.Next(0, 255));
            return override1;

        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            if (datawagelabel.Count > 0)
            {
                datawagelabel.ForEach(
                    delegate(DataWedgeLabel dwl)
                    {
                        e.SceneGraph.Add(dwl.DrawLine);
                        e.SceneGraph.Add(dwl.DrawText);
                    }
                    );

            }
        }

        private void ultraChart1_ChartDrawItem(object sender, Infragistics.UltraChart.Shared.Events.ChartDrawItemEventArgs e)
        {
            
            if (e.Primitive is Wedge && e.Primitive.Value != null)
            {
                DataWedgeLabel dwl = new DataWedgeLabel((Wedge)e.Primitive);

                if(!datawagelabel.Contains(dwl, new MyEqualityComparer()))
                {
                    datawagelabel.Add(dwl);
                    (this.ultraChart1 as IChartComponent).Invalidate(CacheLevel.LayerLevelCache); 
                }
               
            }
        }


    }

    public class DataWedgeLabel
    {
         int offset = 40;

        public  int Offset
        {
            get { return offset; }
            set { offset = value; }
        }

        Line drawLine;
        Text drawText;

        public Text DrawText
        {
            get { return drawText; }
            
        }

        public Line DrawLine
        {
            get
            {
                return drawLine;
            }
        }

        public DataWedgeLabel(Wedge value) 
        {
            Point middleCenter;
            Point endCenter;
            double angle;
            int radius;
            angle = value.startAngle + value.angleSweep / 2;
            angle = angle * Math.PI / 180;
            radius = value.RadiusInner + Math.Abs(value.Radius - value.RadiusInner) / 2;
            middleCenter = new Point((int)(value.Center.X + radius * Math.Cos(angle)),
                (int)(value.Center.Y + radius * Math.Sin(angle)));
            radius += offset;
            endCenter = new Point((int)(value.Center.X + radius * Math.Cos(angle)),
                (int)(value.Center.Y + radius  * Math.Sin(angle)));
            drawLine = new Line(middleCenter, endCenter);
            endCenter.Offset(0, -4);
            drawText = new Text(endCenter, value.Value.ToString());
            drawText.PE.Fill = value.PE.Fill;
            drawLine.PE.Stroke = value.PE.Fill;
        }
    }

    class MyEqualityComparer : IEqualityComparer<DataWedgeLabel>
    {
        #region IEqualityComparer<LegendRow> Members

        public bool Equals(DataWedgeLabel x, DataWedgeLabel y)
        {
            return x.DrawLine.MidPoint.Equals(y.DrawLine.MidPoint) ;

        }

        public int GetHashCode(DataWedgeLabel obj)
        {
            return obj.GetHashCode();
            //throw new NotImplementedException();
        }

        #endregion
    }
}
